create or replace package UDO_PKG_EQUIPDS as

  /*  "  " */
  procedure LIST
  (
    COUT                    out clob    --     
  );

  /*   "  " */
  procedure INS
  (
    SCODE                   in varchar2, -- 
    SNAME                   in varchar2, -- 
    NRN                     out number   --  
  );
  
  /*   "  " */
  procedure DEL
  (
    NRN                     in number   --  
  );
  
  /*   "  "     */
  procedure MAKE
  (
    SEQUIPDS                in varchar2, --   
    SEQOBJKIND              in varchar2, --  
    SDICMUNTS               in varchar2, --   
    SUSERPROCS_DATA         in varchar2, --  
    SEXSSERVICE_UPLOAD      in varchar2, --     
    SEXSSERVICEFN_UPLOAD    in varchar2, --     
    SEXSSERVICE_SEND_MD     in varchar2, --      
    SEXSSERVICEFN_SEND_MD   in varchar2, --      
    SEXSSERVICE_SEND_MDCB   in varchar2, --     Call-back      
    SEXSSERVICEFN_SEND_MDCB in varchar2, --      Call-back      
    SEXSSERVICE_SEND_RQ     in varchar2, --      
    SEXSSERVICEFN_SEND_RQ   in varchar2, --      
    SEXSSERVICE_SEND_RQCB   in varchar2, --     Call-back      
    SEXSSERVICEFN_SEND_RQCB in varchar2, --      Call-back      
    SEXSSERVICE_FRCST_MD    in varchar2, --          
    SEXSSERVICEFN_FRCST_MD  in varchar2, --          
    NEQUIPDS                out number,  --     
    NEQUIPDSCM              out number   --      
  );
  
  /*  "   ( )" */
  procedure CM_CARD
  (
    NEQUIPDSCM              in number,  -- .     
    COUT                    out clob    --    
  );
  
  /*  "   ( )" */
  procedure CM_LIST
  (
    NEQUIPDS                in number,  -- .   
    COUT                    out clob    --  
  );
  
  /*   "   ( )" */
  procedure CM_INS
  (
    NPRN                    in number,   -- 
    SEQOBJKIND              in varchar2, --  
    SDICMUNTS               in varchar2, --   
    SUSERPROCS_DATA         in varchar2, --  
    SEXSSERVICE_UPLOAD      in varchar2, --     
    SEXSSERVICEFN_UPLOAD    in varchar2, --     
    SEXSSERVICE_SEND_MD     in varchar2, --      
    SEXSSERVICEFN_SEND_MD   in varchar2, --      
    SEXSSERVICE_SEND_MDCB   in varchar2, --     Call-back      
    SEXSSERVICEFN_SEND_MDCB in varchar2, --      Call-back      
    SEXSSERVICE_SEND_RQ     in varchar2, --      
    SEXSSERVICEFN_SEND_RQ   in varchar2, --      
    SEXSSERVICE_SEND_RQCB   in varchar2, --     Call-back      
    SEXSSERVICEFN_SEND_RQCB in varchar2, --      Call-back      
    SEXSSERVICE_FRCST_MD    in varchar2, --          
    SEXSSERVICEFN_FRCST_MD  in varchar2, --          
    NRN                     out number   --  
  );
  
  /*   "   ( )" */
  procedure CM_UPD
  (
    NRN                     in number,   --  
    SEQOBJKIND              in varchar2, --  
    SDICMUNTS               in varchar2, --   
    SUSERPROCS_DATA         in varchar2, --  
    SEXSSERVICE_UPLOAD      in varchar2, --     
    SEXSSERVICEFN_UPLOAD    in varchar2, --     
    SEXSSERVICE_SEND_MD     in varchar2, --      
    SEXSSERVICEFN_SEND_MD   in varchar2, --      
    SEXSSERVICE_SEND_MDCB   in varchar2, --     Call-back      
    SEXSSERVICEFN_SEND_MDCB in varchar2, --      Call-back      
    SEXSSERVICE_SEND_RQ     in varchar2, --      
    SEXSSERVICEFN_SEND_RQ   in varchar2, --      
    SEXSSERVICE_SEND_RQCB   in varchar2, --     Call-back      
    SEXSSERVICEFN_SEND_RQCB in varchar2, --      Call-back      
    SEXSSERVICE_FRCST_MD    in varchar2, --          
    SEXSSERVICEFN_FRCST_MD  in varchar2  --          
  );
  
  /*   "   ( )" */
  procedure CM_DEL
  (
    NRN                     in number   --  
  );
  
  /*       "   ( )" */
  procedure CM_DATASET_LIST
  (
    NRN                     in number,         --  
    NSTATUS                 in number := null, --  (null - , .  UDO_PKG_EQUIPDS_BASE.NCMFL_STATUS_*)
    COUT                    out clob           --  
  );
  
  /*  "   ( ,  )" */
  procedure CMFL_LIST
  (
    NEQUIPDSCM              in number,  -- .     
    COUT                    out clob    --     
  );

  /*  "   ( ,  )" */
  procedure CMFL_DEL
  (
    NRN                     in number   --  
  );
  
  /*  "   ( ,  )" */
  procedure CMFL_MAKE
  (
    NEQUIPDSCM              in number,     -- .     
    NDATASET_IDENT          in number,     --   
    NDATASET_CONFIG_IDENT   in number,     --    
    NCLEAR                  in number := 0 --      (0 -  , 1 - )
  );
  
  /*    "   ( ,  )" */
  procedure CMFL_UPLOAD
  (
    NEQUIPDSCM              in number   -- .     
  );

  /*    "   ( ,  )" */
  procedure CMFL_SEND_MD
  (
    NEQUIPDSCM              in number,  -- .     
    NDATASET_ID             in number   --  
  );

  /*  "   ( , )" */
  procedure CMML_LIST
  (
    NEQUIPDSCM              in number,  -- .     
    COUT                    out clob    --     
  );
  
  /*   "   ( , )" */
  procedure CMML_INS
  (
    NPRN                    in number,   -- 
    STASK                   in varchar2, --  (.  UDO_PKG_EQUIPDS_BASE.SCMML_TASK_*)
    NDATASET_ID             in number,   --  
    SUSERPROCS_FRCST_DATA   in varchar2, --      
    NRN                     out number   --  
  );
  
  /*   "   ( , )" */
  procedure CMML_DEL
  (
    NRN                     in number   --  
  );
  
  /*    "   ( , )" */
  procedure CMML_SEND_RQ
  (
    NEQUIPDSCMML            in number   -- .      
  );
  
  /*  "   ( , )"    */
  function CMML_STATUS_BY_EQCONFIG
  (
    NEQCONFIG               in number   -- .    
  ) return                  number;     --     (0 -  , 1 -     , 2 -   )

  /*  "   ( , )"    */
  procedure CMML_LIST_BY_EQCONFIG
  (
    NEQCONFIG               in number,  -- .    
    COUT                    out clob    --       
  );

  /*    "   ( , ,  )" */
  procedure CMMLH_BUILD_FORECAST
  (
    COUT                    out clob    --  
  );
  
  /*      "   ( , ,  )" */
  procedure CMMLH_PARSE_FORECAST
  (
    CFORECAST               in clob,    --  
    NFORECAST               out number  --  
  );
  
  /*  "   ( , ,  )"    */
  procedure CMMLH_LIST_BY_EQCONFIG
  (
    NEQCONFIG               in number,  -- .    
    COUT                    out clob    --       
  );

end UDO_PKG_EQUIPDS;
/
create or replace package body UDO_PKG_EQUIPDS as

  /*  "  " */
  procedure LIST
  (
    COUT                    out clob                               --     
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); --  
    NCUR                    integer;                               --    
    XDOC                    PKG_XMAKE.TNODE;                       --   
    XDS                     PKG_XMAKE.TNODE;                       --    
    NACCESS                 PKG_STD.TNUMBER := 0;                  --      (0 -  , 1 -  )
  begin
    /*    */
    if (UDO_PKG_EQUIPDS_BASE.UTL_ACCESS_CHECK(SUSER   => UTILIZER(),
                                              STABLE  => 'UDO_T_EQUIPDS',
                                              SACTION => 'UDO_EQUIPDS_SELECT')) then
      NACCESS := 1;
    end if;
    /*   */
    NCUR := PKG_XMAKE.OPEN_CURSOR();
    /*    */
    for C in (select T.RN   NRN,
                     T.CODE SCODE,
                     T.NAME SNAME
                from UDO_T_EQUIPDS T
               where T.COMPANY = NCOMPANY
                 and NACCESS = 1
               order by T.NAME)
    loop
      XDS := PKG_XMAKE.CONCAT(ICURSOR => NCUR,
                              RNODE00 => XDS,
                              RNODE01 => PKG_XMAKE.ELEMENT(ICURSOR     => NCUR,
                                                           SNAME       => 'XDS',
                                                           RATTRIBUTES => PKG_XMAKE.ATTRIBUTES(ICURSOR      => NCUR,
                                                                                               RATTRIBUTE00 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                                                   SNAME   => 'NRN',
                                                                                                                                   SVALUE  => C.NRN),
                                                                                               RATTRIBUTE01 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                                                   SNAME   => 'SCODE',
                                                                                                                                   SVALUE  => C.SCODE),
                                                                                               RATTRIBUTE02 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                                                   SNAME   => 'SNAME',
                                                                                                                                   SVALUE  => C.SNAME))));
    end loop;
    /*  XML-  */
    XDOC := PKG_XMAKE.ELEMENT(ICURSOR => NCUR,
                              SNAME   => 'XDATA',
                              RNODE00 => XDS,
                              RNODE01 => PKG_XMAKE.ELEMENT(ICURSOR  => NCUR,
                                                           SNAME    => 'NACCESS',
                                                           RVALUE00 => PKG_XMAKE.VALUE(ICURSOR => NCUR, NVALUE => NACCESS)));
    /*   CLOB */
    COUT := PKG_XMAKE.SERIALIZE_TO_CLOB(ICURSOR => NCUR,
                                        ITYPE   => PKG_XMAKE.CONTENT_,
                                        RNODE   => XDOC,
                                        RHEADER => PKG_XHEADER.WRAP_ALL(SVERSION    => PKG_XHEADER.VERSION_1_0_,
                                                                        SENCODING   => PKG_XHEADER.ENCODING_UTF_,
                                                                        SSTANDALONE => PKG_XHEADER.STANDALONE_YES_));
    /*   */
    PKG_XMAKE.CLOSE_CURSOR(ICURSOR => NCUR);
  end LIST;
  
  /*   "  " */
  procedure INS
  (
    SCODE                   in varchar2,                           -- 
    SNAME                   in varchar2,                           -- 
    NRN                     out number                             --  
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); -- 
  begin
    /*   */
    if (SCODE is null) then
      P_EXCEPTION(0, '  .');
    end if;
    if (SNAME is null) then
      P_EXCEPTION(0, '  .');
    end if;
    /*    */
    UDO_PKG_EQUIPDS_BASE.UTL_ACCESS(STABLE => 'UDO_T_EQUIPDS', SACTION => 'UDO_EQUIPDS_INSERT');
    /*   */
    UDO_PKG_EQUIPDS_BASE.INS(NCOMPANY => NCOMPANY, SCODE => SCODE, SNAME => SNAME, NRN => NRN);
  end INS;

  /*   "  " */
  procedure DEL
  (
    NRN                     in number                              --  
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); -- 
  begin
    /*    */
    UDO_PKG_EQUIPDS_BASE.UTL_ACCESS(STABLE => 'UDO_T_EQUIPDS', SACTION => 'UDO_EQUIPDS_DELETE', NDOCUMENT => NRN);
    /*   */
    UDO_PKG_EQUIPDS_BASE.DEL(NRN => NRN, NCOMPANY => NCOMPANY);
  end DEL;
  
  /*   "  "     */
  procedure MAKE
  (
    SEQUIPDS                in varchar2,                           --   
    SEQOBJKIND              in varchar2,                           --  
    SDICMUNTS               in varchar2,                           --   
    SUSERPROCS_DATA         in varchar2,                           --  
    SEXSSERVICE_UPLOAD      in varchar2,                           --     
    SEXSSERVICEFN_UPLOAD    in varchar2,                           --     
    SEXSSERVICE_SEND_MD     in varchar2,                           --      
    SEXSSERVICEFN_SEND_MD   in varchar2,                           --      
    SEXSSERVICE_SEND_MDCB   in varchar2,                           --     Call-back      
    SEXSSERVICEFN_SEND_MDCB in varchar2,                           --      Call-back      
    SEXSSERVICE_SEND_RQ     in varchar2,                           --      
    SEXSSERVICEFN_SEND_RQ   in varchar2,                           --      
    SEXSSERVICE_SEND_RQCB   in varchar2,                           --     Call-back      
    SEXSSERVICEFN_SEND_RQCB in varchar2,                           --      Call-back      
    SEXSSERVICE_FRCST_MD    in varchar2,                           --          
    SEXSSERVICEFN_FRCST_MD  in varchar2,                           --          
    NEQUIPDS                out number,                            --     
    NEQUIPDSCM              out number                             --      
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); --     
  begin
    /*   */
    if (SEQUIPDS is null) then
      P_EXCEPTION(0, '   .');
    end if;
    if (SEQOBJKIND is null) then
      P_EXCEPTION(0, '   .');
    end if;
    if (SDICMUNTS is null) then
      P_EXCEPTION(0, '    .');
    end if;
    if (SUSERPROCS_DATA is null) then
      P_EXCEPTION(0, '     .');
    end if;
    if ((SEXSSERVICE_UPLOAD is null) or (SEXSSERVICEFN_UPLOAD is null)) then
      P_EXCEPTION(0, '      .');
    end if;
    if ((SEXSSERVICE_SEND_MD is null) or (SEXSSERVICEFN_SEND_MD is null)) then
      P_EXCEPTION(0,
                  '       .');
    end if;
    if ((SEXSSERVICE_SEND_MDCB is null) or (SEXSSERVICEFN_SEND_MDCB is null)) then
      P_EXCEPTION(0,
                  '           .');
    end if;
    if ((SEXSSERVICE_SEND_RQ is null) or (SEXSSERVICEFN_SEND_RQ is null)) then
      P_EXCEPTION(0,
                  '       .');
    end if;
    if ((SEXSSERVICE_SEND_RQCB is null) or (SEXSSERVICEFN_SEND_RQCB is null)) then
      P_EXCEPTION(0,
                  '           .');
    end if;
    if ((SEXSSERVICE_FRCST_MD is null) or (SEXSSERVICEFN_FRCST_MD is null)) then
      P_EXCEPTION(0,
                  '           .');
    end if;
    /*    */
    UDO_PKG_EQUIPDS_BASE.UTL_ACCESS(STABLE => 'UDO_T_EQUIPDS', SACTION => 'UDO_EQUIPDS_MAKE');
    /*     */
    UDO_PKG_EQUIPDS_BASE.FIND_BY_CODE(NFLAG_SMART => 1, NCOMPANY => NCOMPANY, SCODE => SEQUIPDS, NRN => NEQUIPDS);
    /*   */
    if (NEQUIPDS is null) then
      /*    */
      INS(SCODE => SEQUIPDS, SNAME => SEQUIPDS, NRN => NEQUIPDS);
    else
      /*   -        */
      UDO_PKG_EQUIPDS_BASE.CM_FIND_BY_EQOBJKIND(NFLAG_SMART => 1,
                                                NCOMPANY    => NCOMPANY,
                                                SEQOBJKIND  => SEQOBJKIND,
                                                NRN         => NEQUIPDSCM);
    end if;
    /*      */
    if (NEQUIPDSCM is null) then
      /*     */
      CM_INS(NPRN                    => NEQUIPDS,
             SEQOBJKIND              => SEQOBJKIND,
             SDICMUNTS               => SDICMUNTS,
             SUSERPROCS_DATA         => SUSERPROCS_DATA,
             SEXSSERVICE_UPLOAD      => SEXSSERVICE_UPLOAD,
             SEXSSERVICEFN_UPLOAD    => SEXSSERVICEFN_UPLOAD,
             SEXSSERVICE_SEND_MD     => SEXSSERVICE_SEND_MD,
             SEXSSERVICEFN_SEND_MD   => SEXSSERVICEFN_SEND_MD,
             SEXSSERVICE_SEND_MDCB   => SEXSSERVICE_SEND_MDCB,
             SEXSSERVICEFN_SEND_MDCB => SEXSSERVICEFN_SEND_MDCB,
             SEXSSERVICE_SEND_RQ     => SEXSSERVICE_SEND_RQ,
             SEXSSERVICEFN_SEND_RQ   => SEXSSERVICEFN_SEND_RQ,
             SEXSSERVICE_SEND_RQCB   => SEXSSERVICE_SEND_RQCB,
             SEXSSERVICEFN_SEND_RQCB => SEXSSERVICEFN_SEND_RQCB,
             SEXSSERVICE_FRCST_MD    => SEXSSERVICE_FRCST_MD,
             SEXSSERVICEFN_FRCST_MD  => SEXSSERVICEFN_FRCST_MD,
             NRN                     => NEQUIPDSCM);
    end if;
  end MAKE;
  
  /*  "   ( )" */
  procedure CM_CARD
  (
    NEQUIPDSCM              in number,       -- .     
    COUT                    out clob         --  
  )
  is  
    NCUR                    integer;         --    
    XDOC                    PKG_XMAKE.TNODE; --   
    XEQUIPDSCM              PKG_XMAKE.TNODE; --   
  begin
    /*    */
    UDO_PKG_EQUIPDS_BASE.UTL_ACCESS(STABLE => 'UDO_T_EQUIPDSCM', SACTION => 'UDO_EQUIPDSCM_SELECT');
    /*   */
    NCUR := PKG_XMAKE.OPEN_CURSOR();
    /*      */
    for C in (select T.RN NRN,
                     FORMAT_HIER_NAME(null, null, OK.FULLCODE) SSEQOBJKIND,
                     OK.NAME SNAME,
                     DM.MEAS_MNEMO SDICMUNTS,
                     UP.CODE SUSERPROCS_DATA,
                     SU.CODE SEXSSERVICE_UPLOAD,
                     SFU.CODE SEXSSERVICEFN_UPLOAD,
                     SMD.CODE SEXSSERVICE_SEND_MD,
                     SFMD.CODE SEXSSERVICEFN_SEND_MD,
                     SMDCB.CODE SEXSSERVICE_SEND_MDCB,
                     SFMDCB.CODE SEXSSERVICEFN_SEND_MDCB,
                     SRQ.CODE SEXSSERVICE_SEND_RQ,
                     SFRQ.CODE SEXSSERVICEFN_SEND_RQ,
                     SRQCB.CODE SEXSSERVICE_SEND_RQCB,
                     SFRQCB.CODE SEXSSERVICEFN_SEND_RQCB,
                     SFCMD.CODE SEXSSERVICE_FRCST_MD,
                     SFFCMD.CODE SEXSSERVICEFN_FRCST_MD
                from UDO_T_EQUIPDSCM T,
                     EQOBJKIND       OK,
                     USERPROCS       UP,
                     EXSSERVICE      SU,
                     EXSSERVICEFN    SFU,
                     EXSSERVICE      SMD,
                     EXSSERVICEFN    SFMD,
                     EXSSERVICE      SMDCB,
                     EXSSERVICEFN    SFMDCB,
                     EXSSERVICE      SRQ,
                     EXSSERVICEFN    SFRQ,
                     EXSSERVICE      SRQCB,
                     EXSSERVICEFN    SFRQCB,
                     EXSSERVICE      SFCMD,
                     EXSSERVICEFN    SFFCMD,
                     DICMUNTS        DM
               where T.RN = NEQUIPDSCM
                 and T.EQOBJKIND = OK.RN
                 and T.USERPROCS_DATA = UP.RN
                 and T.EXSSERVICEFN_UPLOAD = SFU.RN
                 and SFU.PRN = SU.RN
                 and T.EXSSERVICEFN_SEND_MD = SFMD.RN
                 and SFMD.PRN = SMD.RN
                 and T.EXSSERVICEFN_SEND_MDCB = SFMDCB.RN
                 and SFMDCB.PRN = SMDCB.RN
                 and T.EXSSERVICEFN_SEND_RQ = SFRQ.RN
                 and SFRQ.PRN = SRQ.RN
                 and T.EXSSERVICEFN_SEND_RQCB = SFRQCB.RN
                 and SFRQCB.PRN = SRQCB.RN                 
                 and T.EXSSERVICEFN_FRCST_MD = SFFCMD.RN
                 and SFFCMD.PRN = SFCMD.RN                 
                 and T.DICMUNTS = DM.RN)
    loop
      /*     */
      XEQUIPDSCM := PKG_XMAKE.ELEMENT(ICURSOR     => NCUR,
                                      SNAME       => 'XEQUIPDSCM',
                                      RATTRIBUTES => PKG_XMAKE.ATTRIBUTES(ICURSOR      => NCUR,
                                                                          RATTRIBUTE00 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                              SNAME   => 'NRN',
                                                                                                              SVALUE  => C.NRN),
                                                                          RATTRIBUTE01 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                              SNAME   => 'SSEQOBJKIND',
                                                                                                              SVALUE  => C.SSEQOBJKIND),
                                                                          RATTRIBUTE02 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                              SNAME   => 'SNAME',
                                                                                                              SVALUE  => C.SNAME),
                                                                          RATTRIBUTE03 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                              SNAME   => 'SDICMUNTS',
                                                                                                              SVALUE  => C.SDICMUNTS),
                                                                          RATTRIBUTE04 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                              SNAME   => 'SUSERPROCS_DATA',
                                                                                                              SVALUE  => C.SUSERPROCS_DATA),
                                                                          RATTRIBUTE05 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                              SNAME   => 'SEXSSERVICE_UPLOAD',
                                                                                                              SVALUE  => C.SEXSSERVICE_UPLOAD),
                                                                          RATTRIBUTE06 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                              SNAME   => 'SEXSSERVICEFN_UPLOAD',
                                                                                                              SVALUE  => C.SEXSSERVICEFN_UPLOAD),
                                                                          RATTRIBUTE07 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                              SNAME   => 'SEXSSERVICE_SEND_MD',
                                                                                                              SVALUE  => C.SEXSSERVICE_SEND_MD),
                                                                          RATTRIBUTE08 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                              SNAME   => 'SEXSSERVICEFN_SEND_MD',
                                                                                                              SVALUE  => C.SEXSSERVICEFN_SEND_MD),
                                                                          RATTRIBUTE09 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                              SNAME   => 'SEXSSERVICE_SEND_MDCB',
                                                                                                              SVALUE  => C.SEXSSERVICE_SEND_MDCB),
                                                                          RATTRIBUTE10 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                              SNAME   => 'SEXSSERVICEFN_SEND_MDCB',
                                                                                                              SVALUE  => C.SEXSSERVICEFN_SEND_MDCB),
                                                                          RATTRIBUTE11 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                              SNAME   => 'SEXSSERVICE_SEND_RQ',
                                                                                                              SVALUE  => C.SEXSSERVICE_SEND_RQ),
                                                                          RATTRIBUTE12 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                              SNAME   => 'SEXSSERVICEFN_SEND_RQ',
                                                                                                              SVALUE  => C.SEXSSERVICEFN_SEND_RQ),
                                                                          RATTRIBUTE13 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                              SNAME   => 'SEXSSERVICE_SEND_RQCB',
                                                                                                              SVALUE  => C.SEXSSERVICE_SEND_RQCB),
                                                                          RATTRIBUTE14 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                              SNAME   => 'SEXSSERVICEFN_SEND_RQCB',
                                                                                                              SVALUE  => C.SEXSSERVICEFN_SEND_RQCB),
                                                                          RATTRIBUTE15 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                              SNAME   => 'SEXSSERVICE_FRCST_MD',
                                                                                                              SVALUE  => C.SEXSSERVICE_FRCST_MD),
                                                                          RATTRIBUTE16 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                              SNAME   => 'SEXSSERVICEFN_FRCST_MD',
                                                                                                              SVALUE  => C.SEXSSERVICEFN_FRCST_MD)));
    end loop;
    /*  XML-  */
    XDOC := PKG_XMAKE.ELEMENT(ICURSOR => NCUR, SNAME => 'XDATA', RNODE00 => XEQUIPDSCM);
    /*   CLOB */
    COUT := PKG_XMAKE.SERIALIZE_TO_CLOB(ICURSOR => NCUR,
                                        ITYPE   => PKG_XMAKE.CONTENT_,
                                        RNODE   => XDOC,
                                        RHEADER => PKG_XHEADER.WRAP_ALL(SVERSION    => PKG_XHEADER.VERSION_1_0_,
                                                                        SENCODING   => PKG_XHEADER.ENCODING_UTF_,
                                                                        SSTANDALONE => PKG_XHEADER.STANDALONE_YES_));
    /*   */
    PKG_XMAKE.CLOSE_CURSOR(ICURSOR => NCUR);
  end CM_CARD;
  
  /*  "   ( )" */
  procedure CM_LIST
  (
    NEQUIPDS                in number,       -- .   
    COUT                    out clob         --  
  )
  is  
    NCUR                    integer;         --    
    XDOC                    PKG_XMAKE.TNODE; --   
    XDSCM                   PKG_XMAKE.TNODE; --    
  begin
    /*    */
    UDO_PKG_EQUIPDS_BASE.UTL_ACCESS(STABLE => 'UDO_T_EQUIPDSCM', SACTION => 'UDO_EQUIPDSCM_SELECT');
    /*   */
    NCUR := PKG_XMAKE.OPEN_CURSOR();
    /*       */
    for C in (select T.RN          NRN,
                     OK.CODE       SCODE,
                     OK.NAME       SNAME,
                     DM.MEAS_MNEMO SDICMUNTS,
                     UPD.CODE      SUSERPROCS_DATA,
                     UPL.CODE      SEXSSERVICEFN_UPLOAD,
                     SMD.CODE      SEXSSERVICEFN_SEND_MD,
                     SRQ.CODE      SEXSSERVICEFN_SEND_RQ
                from UDO_T_EQUIPDSCM T,
                     EQOBJKIND       OK,
                     DICMUNTS        DM,
                     USERPROCS       UPD,
                     EXSSERVICEFN    UPL,
                     EXSSERVICEFN    SMD,
                     EXSSERVICEFN    SRQ
               where T.PRN = NEQUIPDS
                 and T.EQOBJKIND = OK.RN
                 and T.DICMUNTS = DM.RN
                 and T.USERPROCS_DATA = UPD.RN
                 and T.EXSSERVICEFN_UPLOAD = UPL.RN
                 and T.EXSSERVICEFN_SEND_MD = SMD.RN
                 and T.EXSSERVICEFN_SEND_RQ = SRQ.RN
               order by OK.CODE)
    loop
      XDSCM := PKG_XMAKE.CONCAT(ICURSOR => NCUR,
                                RNODE00 => XDSCM,
                                RNODE01 => PKG_XMAKE.ELEMENT(ICURSOR     => NCUR,
                                                             SNAME       => 'XDSCM',
                                                             RATTRIBUTES => PKG_XMAKE.ATTRIBUTES(ICURSOR      => NCUR,
                                                                                                 RATTRIBUTE00 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                                                     SNAME   => 'NRN',
                                                                                                                                     SVALUE  => C.NRN),
                                                                                                 RATTRIBUTE01 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                                                     SNAME   => 'SCODE',
                                                                                                                                     SVALUE  => C.SCODE),
                                                                                                 RATTRIBUTE02 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                                                     SNAME   => 'SNAME',
                                                                                                                                     SVALUE  => C.SNAME),
                                                                                                 RATTRIBUTE03 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                                                     SNAME   => 'SDICMUNTS',
                                                                                                                                     SVALUE  => C.SDICMUNTS),
                                                                                                 RATTRIBUTE04 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                                                     SNAME   => 'SUSERPROCS_DATA',
                                                                                                                                     SVALUE  => C.SUSERPROCS_DATA),
                                                                                                 RATTRIBUTE05 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                                                     SNAME   => 'SEXSSERVICEFN_UPLOAD',
                                                                                                                                     SVALUE  => C.SEXSSERVICEFN_UPLOAD),
                                                                                                 RATTRIBUTE06 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                                                     SNAME   => 'SEXSSERVICEFN_SEND_MD',
                                                                                                                                     SVALUE  => C.SEXSSERVICEFN_SEND_MD),
                                                                                                 RATTRIBUTE07 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                                                     SNAME   => 'SEXSSERVICEFN_SEND_RQ',
                                                                                                                                     SVALUE  => C.SEXSSERVICEFN_SEND_RQ))));
    end loop;
    /*  XML-  */
    XDOC := PKG_XMAKE.ELEMENT(ICURSOR => NCUR, SNAME => 'XDATA', RNODE00 => XDSCM);
    /*   CLOB */
    COUT := PKG_XMAKE.SERIALIZE_TO_CLOB(ICURSOR => NCUR,
                                        ITYPE   => PKG_XMAKE.CONTENT_,
                                        RNODE   => XDOC,
                                        RHEADER => PKG_XHEADER.WRAP_ALL(SVERSION    => PKG_XHEADER.VERSION_1_0_,
                                                                        SENCODING   => PKG_XHEADER.ENCODING_UTF_,
                                                                        SSTANDALONE => PKG_XHEADER.STANDALONE_YES_));
    /*   */
    PKG_XMAKE.CLOSE_CURSOR(ICURSOR => NCUR);
  end CM_LIST;
  
  /*   "   ( )" */
  procedure CM_INS
  (
    NPRN                    in number,                             -- 
    SEQOBJKIND              in varchar2,                           --  
    SDICMUNTS               in varchar2,                           --   
    SUSERPROCS_DATA         in varchar2,                           --  
    SEXSSERVICE_UPLOAD      in varchar2,                           --     
    SEXSSERVICEFN_UPLOAD    in varchar2,                           --     
    SEXSSERVICE_SEND_MD     in varchar2,                           --      
    SEXSSERVICEFN_SEND_MD   in varchar2,                           --      
    SEXSSERVICE_SEND_MDCB   in varchar2,                           --     Call-back      
    SEXSSERVICEFN_SEND_MDCB in varchar2,                           --      Call-back      
    SEXSSERVICE_SEND_RQ     in varchar2,                           --      
    SEXSSERVICEFN_SEND_RQ   in varchar2,                           --      
    SEXSSERVICE_SEND_RQCB   in varchar2,                           --     Call-back      
    SEXSSERVICEFN_SEND_RQCB in varchar2,                           --      Call-back      
    SEXSSERVICE_FRCST_MD    in varchar2,                           --          
    SEXSSERVICEFN_FRCST_MD  in varchar2,                           --          
    NRN                     out number                             --  
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); -- 
    NEQOBJKIND              PKG_STD.TREF;                          -- .   
    NDICMUNTS               PKG_STD.TREF;                          -- .    
    NUSERPROCS_DATA         PKG_STD.TREF;                          -- .   
    NEXSSERVICEFN_UPLOAD    PKG_STD.TREF;                          -- .      
    NEXSSERVICEFN_SEND_MD   PKG_STD.TREF;                          -- .       
    NEXSSERVICEFN_SEND_MDCB PKG_STD.TREF;                          -- .  call-back      
    NEXSSERVICEFN_SEND_RQ   PKG_STD.TREF;                          -- .       
    NEXSSERVICEFN_SEND_RQCB PKG_STD.TREF;                          -- .  call-back      
    NEXSSERVICEFN_FRCST_MD  PKG_STD.TREF;                          -- .           
  begin
    /*   */
    if (NPRN is null) then
      P_EXCEPTION(0, '    .');
    end if;
    if (SEQOBJKIND is null) then
      P_EXCEPTION(0, '   .');
    end if;
    if (SDICMUNTS is null) then
      P_EXCEPTION(0, '    .');
    end if;
    if (SUSERPROCS_DATA is null) then
      P_EXCEPTION(0, '     .');
    end if;
    if ((SEXSSERVICE_UPLOAD is null) or (SEXSSERVICEFN_UPLOAD is null)) then
      P_EXCEPTION(0, '      .');
    end if;
    if ((SEXSSERVICE_SEND_MD is null) or (SEXSSERVICEFN_SEND_MD is null)) then
      P_EXCEPTION(0,
                  '       .');
    end if;
    if ((SEXSSERVICE_SEND_MDCB is null) or (SEXSSERVICEFN_SEND_MDCB is null)) then
      P_EXCEPTION(0,
                  '           .');
    end if;
    if ((SEXSSERVICE_SEND_RQ is null) or (SEXSSERVICEFN_SEND_RQ is null)) then
      P_EXCEPTION(0,
                  '       .');
    end if;
    if ((SEXSSERVICE_SEND_RQCB is null) or (SEXSSERVICEFN_SEND_RQCB is null)) then
      P_EXCEPTION(0,
                  '           .');
    end if;
    if ((SEXSSERVICE_FRCST_MD is null) or (SEXSSERVICEFN_FRCST_MD is null)) then
      P_EXCEPTION(0,
                  '           .');
    end if;
    /*    */
    UDO_PKG_EQUIPDS_BASE.UTL_ACCESS(STABLE => 'UDO_T_EQUIPDSCM', SACTION => 'UDO_EQUIPDSCM_INSERT');
    /*   */
    UDO_PKG_EQUIPDS_BASE.CM_JOINS(NCOMPANY                => NCOMPANY,
                                  SEQOBJKIND              => SEQOBJKIND,
                                  SDICMUNTS               => SDICMUNTS,
                                  SUSERPROCS_DATA         => SUSERPROCS_DATA,
                                  SEXSSERVICE_UPLOAD      => SEXSSERVICE_UPLOAD,
                                  SEXSSERVICEFN_UPLOAD    => SEXSSERVICEFN_UPLOAD,
                                  SEXSSERVICE_SEND_MD     => SEXSSERVICE_SEND_MD,
                                  SEXSSERVICEFN_SEND_MD   => SEXSSERVICEFN_SEND_MD,
                                  SEXSSERVICE_SEND_MDCB   => SEXSSERVICE_SEND_MDCB,
                                  SEXSSERVICEFN_SEND_MDCB => SEXSSERVICEFN_SEND_MDCB,
                                  SEXSSERVICE_SEND_RQ     => SEXSSERVICE_SEND_RQ,
                                  SEXSSERVICEFN_SEND_RQ   => SEXSSERVICEFN_SEND_RQ,
                                  SEXSSERVICE_SEND_RQCB   => SEXSSERVICE_SEND_RQCB,
                                  SEXSSERVICEFN_SEND_RQCB => SEXSSERVICEFN_SEND_RQCB,
                                  SEXSSERVICE_FRCST_MD    => SEXSSERVICE_FRCST_MD,
                                  SEXSSERVICEFN_FRCST_MD  => SEXSSERVICEFN_FRCST_MD,
                                  NEQOBJKIND              => NEQOBJKIND,
                                  NDICMUNTS               => NDICMUNTS,
                                  NUSERPROCS_DATA         => NUSERPROCS_DATA,
                                  NEXSSERVICEFN_UPLOAD    => NEXSSERVICEFN_UPLOAD,
                                  NEXSSERVICEFN_SEND_MD   => NEXSSERVICEFN_SEND_MD,
                                  NEXSSERVICEFN_SEND_MDCB => NEXSSERVICEFN_SEND_MDCB,
                                  NEXSSERVICEFN_SEND_RQ   => NEXSSERVICEFN_SEND_RQ,
                                  NEXSSERVICEFN_SEND_RQCB => NEXSSERVICEFN_SEND_RQCB,
                                  NEXSSERVICEFN_FRCST_MD  => NEXSSERVICEFN_FRCST_MD);
    /*   */
    UDO_PKG_EQUIPDS_BASE.CM_INS(NPRN                    => NPRN,
                                NEQOBJKIND              => NEQOBJKIND,
                                NDICMUNTS               => NDICMUNTS,
                                NUSERPROCS_DATA         => NUSERPROCS_DATA,
                                NEXSSERVICEFN_UPLOAD    => NEXSSERVICEFN_UPLOAD,
                                NEXSSERVICEFN_SEND_MD   => NEXSSERVICEFN_SEND_MD,
                                NEXSSERVICEFN_SEND_MDCB => NEXSSERVICEFN_SEND_MDCB,
                                NEXSSERVICEFN_SEND_RQ   => NEXSSERVICEFN_SEND_RQ,
                                NEXSSERVICEFN_SEND_RQCB => NEXSSERVICEFN_SEND_RQCB,
                                NEXSSERVICEFN_FRCST_MD  => NEXSSERVICEFN_FRCST_MD,
                                NRN                     => NRN);
  end CM_INS;

  /*   "   ( )" */
  procedure CM_UPD
  (
    NRN                     in number,                             --  
    SEQOBJKIND              in varchar2,                           --  
    SDICMUNTS               in varchar2,                           --   
    SUSERPROCS_DATA         in varchar2,                           --  
    SEXSSERVICE_UPLOAD      in varchar2,                           --     
    SEXSSERVICEFN_UPLOAD    in varchar2,                           --     
    SEXSSERVICE_SEND_MD     in varchar2,                           --      
    SEXSSERVICEFN_SEND_MD   in varchar2,                           --      
    SEXSSERVICE_SEND_MDCB   in varchar2,                           --     Call-back      
    SEXSSERVICEFN_SEND_MDCB in varchar2,                           --      Call-back      
    SEXSSERVICE_SEND_RQ     in varchar2,                           --      
    SEXSSERVICEFN_SEND_RQ   in varchar2,                           --      
    SEXSSERVICE_SEND_RQCB   in varchar2,                           --     Call-back      
    SEXSSERVICEFN_SEND_RQCB in varchar2,                           --      Call-back      
    SEXSSERVICE_FRCST_MD    in varchar2,                           --          
    SEXSSERVICEFN_FRCST_MD  in varchar2                            --          
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); -- 
    NEQOBJKIND              PKG_STD.TREF;                          -- .   
    NDICMUNTS               PKG_STD.TREF;                          -- .    
    NUSERPROCS_DATA         PKG_STD.TREF;                          -- .   
    NEXSSERVICEFN_UPLOAD    PKG_STD.TREF;                          -- .      
    NEXSSERVICEFN_SEND_MD   PKG_STD.TREF;                          -- .       
    NEXSSERVICEFN_SEND_MDCB PKG_STD.TREF;                          -- .  call-back      
    NEXSSERVICEFN_SEND_RQ   PKG_STD.TREF;                          -- .       
    NEXSSERVICEFN_SEND_RQCB PKG_STD.TREF;                          -- .  call-back      
    NEXSSERVICEFN_FRCST_MD  PKG_STD.TREF;                          -- .           
  begin
    /*   */
    if (NRN is null) then
      P_EXCEPTION(0, '       .');
    end if;
    if (SEQOBJKIND is null) then
      P_EXCEPTION(0, '   .');
    end if;
    if (SDICMUNTS is null) then
      P_EXCEPTION(0, '    .');
    end if;
    if (SUSERPROCS_DATA is null) then
      P_EXCEPTION(0, '     .');
    end if;
    if ((SEXSSERVICE_UPLOAD is null) or (SEXSSERVICEFN_UPLOAD is null)) then
      P_EXCEPTION(0, '      .');
    end if;
    if ((SEXSSERVICE_SEND_MD is null) or (SEXSSERVICEFN_SEND_MD is null)) then
      P_EXCEPTION(0,
                  '       .');
    end if;
    if ((SEXSSERVICE_SEND_MDCB is null) or (SEXSSERVICEFN_SEND_MDCB is null)) then
      P_EXCEPTION(0,
                  '           .');
    end if;
    if ((SEXSSERVICE_SEND_RQ is null) or (SEXSSERVICEFN_SEND_RQ is null)) then
      P_EXCEPTION(0,
                  '       .');
    end if;
    if ((SEXSSERVICE_SEND_RQCB is null) or (SEXSSERVICEFN_SEND_RQCB is null)) then
      P_EXCEPTION(0,
                  '           .');
    end if;
    if ((SEXSSERVICE_FRCST_MD is null) or (SEXSSERVICEFN_FRCST_MD is null)) then
      P_EXCEPTION(0,
                  '           .');
    end if;
    /*    */
    UDO_PKG_EQUIPDS_BASE.UTL_ACCESS(STABLE => 'UDO_T_EQUIPDSCM', SACTION => 'UDO_EQUIPDSCM_UPDATE');
    /*   */
    UDO_PKG_EQUIPDS_BASE.CM_JOINS(NCOMPANY                => NCOMPANY,
                                  SEQOBJKIND              => SEQOBJKIND,
                                  SDICMUNTS               => SDICMUNTS,
                                  SUSERPROCS_DATA         => SUSERPROCS_DATA,
                                  SEXSSERVICE_UPLOAD      => SEXSSERVICE_UPLOAD,
                                  SEXSSERVICEFN_UPLOAD    => SEXSSERVICEFN_UPLOAD,
                                  SEXSSERVICE_SEND_MD     => SEXSSERVICE_SEND_MD,
                                  SEXSSERVICEFN_SEND_MD   => SEXSSERVICEFN_SEND_MD,
                                  SEXSSERVICE_SEND_MDCB   => SEXSSERVICE_SEND_MDCB,
                                  SEXSSERVICEFN_SEND_MDCB => SEXSSERVICEFN_SEND_MDCB,
                                  SEXSSERVICE_SEND_RQ     => SEXSSERVICE_SEND_RQ,
                                  SEXSSERVICEFN_SEND_RQ   => SEXSSERVICEFN_SEND_RQ,
                                  SEXSSERVICE_SEND_RQCB   => SEXSSERVICE_SEND_RQCB,
                                  SEXSSERVICEFN_SEND_RQCB => SEXSSERVICEFN_SEND_RQCB,
                                  SEXSSERVICE_FRCST_MD    => SEXSSERVICE_FRCST_MD,
                                  SEXSSERVICEFN_FRCST_MD  => SEXSSERVICEFN_FRCST_MD,
                                  NEQOBJKIND              => NEQOBJKIND,
                                  NDICMUNTS               => NDICMUNTS,
                                  NUSERPROCS_DATA         => NUSERPROCS_DATA,
                                  NEXSSERVICEFN_UPLOAD    => NEXSSERVICEFN_UPLOAD,
                                  NEXSSERVICEFN_SEND_MD   => NEXSSERVICEFN_SEND_MD,
                                  NEXSSERVICEFN_SEND_MDCB => NEXSSERVICEFN_SEND_MDCB,
                                  NEXSSERVICEFN_SEND_RQ   => NEXSSERVICEFN_SEND_RQ,
                                  NEXSSERVICEFN_SEND_RQCB => NEXSSERVICEFN_SEND_RQCB,
                                  NEXSSERVICEFN_FRCST_MD  => NEXSSERVICEFN_FRCST_MD);
    /*   */
    UDO_PKG_EQUIPDS_BASE.CM_UPD(NRN                     => NRN,
                                NEQOBJKIND              => NEQOBJKIND,
                                NDICMUNTS               => NDICMUNTS,
                                NUSERPROCS_DATA         => NUSERPROCS_DATA,
                                NEXSSERVICEFN_UPLOAD    => NEXSSERVICEFN_UPLOAD,
                                NEXSSERVICEFN_SEND_MD   => NEXSSERVICEFN_SEND_MD,
                                NEXSSERVICEFN_SEND_MDCB => NEXSSERVICEFN_SEND_MDCB,
                                NEXSSERVICEFN_SEND_RQ   => NEXSSERVICEFN_SEND_RQ,
                                NEXSSERVICEFN_SEND_RQCB => NEXSSERVICEFN_SEND_RQCB,
                                NEXSSERVICEFN_FRCST_MD  => NEXSSERVICEFN_FRCST_MD);
  end CM_UPD;

  /*   "   ( )" */
  procedure CM_DEL
  (
    NRN                     in number   --  
  )
  is
  begin
    /*    */
    UDO_PKG_EQUIPDS_BASE.UTL_ACCESS(STABLE => 'UDO_T_EQUIPDSCM', SACTION => 'UDO_EQUIPDSCM_DELETE', NDOCUMENT => NRN);
    /*   */
    UDO_PKG_EQUIPDS_BASE.CM_DEL(NRN => NRN);
  end CM_DEL;
  
  /*       "   ( )" */
  procedure CM_DATASET_LIST
  (
    NRN                     in number,         --  
    NSTATUS                 in number := null, --  (null - , .  UDO_PKG_EQUIPDS_BASE.NCMFL_STATUS_*)
    COUT                    out clob           --    
  )
  is
    NCUR                    integer;           --    
    XDOC                    PKG_XMAKE.TNODE;   --   
    XDSCM_DATASET           PKG_XMAKE.TNODE;   --    
  begin
    /*    */
    UDO_PKG_EQUIPDS_BASE.UTL_ACCESS(STABLE => 'UDO_T_EQUIPDSCM', SACTION => 'UDO_EQUIPDSCM_SELECT');
    /*   */
    NCUR := PKG_XMAKE.OPEN_CURSOR();
    /*  ,     */
    for C in (select distinct T.DATASET_ID NDATASET_ID,
                              T.DATASET_TS DDATASET_TS
                from UDO_T_EQUIPDSCMFL T
               where T.PRN = NRN
                 and ((NSTATUS is null) or ((NSTATUS is not null) and (T.STATUS = NSTATUS)))
               order by T.DATASET_TS)
    loop
      XDSCM_DATASET := PKG_XMAKE.CONCAT(ICURSOR => NCUR,
                                        RNODE00 => XDSCM_DATASET,
                                        RNODE01 => PKG_XMAKE.ELEMENT(ICURSOR     => NCUR,
                                                                     SNAME       => 'XDSCM_DATASET',
                                                                     RATTRIBUTES => PKG_XMAKE.ATTRIBUTES(ICURSOR      => NCUR,
                                                                                                         RATTRIBUTE00 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                                                             SNAME   => 'value',
                                                                                                                                             SVALUE  => C.NDATASET_ID),
                                                                                                         RATTRIBUTE01 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                                                             SNAME   => 'name',
                                                                                                                                             SVALUE  => UDO_PKG_EQUIPDS_BASE.UTL_DATASET_MAKE_NAME(NDATASET_ID => C.NDATASET_ID,
                                                                                                                                                                                                   DDATASET_TS => C.DDATASET_TS)))));
    end loop;
    /*  XML-  */
    XDOC := PKG_XMAKE.ELEMENT(ICURSOR => NCUR, SNAME => 'XDATA', RNODE00 => XDSCM_DATASET);
    /*   CLOB */
    COUT := PKG_XMAKE.SERIALIZE_TO_CLOB(ICURSOR => NCUR,
                                        ITYPE   => PKG_XMAKE.CONTENT_,
                                        RNODE   => XDOC,
                                        RHEADER => PKG_XHEADER.WRAP_ALL(SVERSION    => PKG_XHEADER.VERSION_1_0_,
                                                                        SENCODING   => PKG_XHEADER.ENCODING_UTF_,
                                                                        SSTANDALONE => PKG_XHEADER.STANDALONE_YES_));
    /*   */
    PKG_XMAKE.CLOSE_CURSOR(ICURSOR => NCUR);
  end CM_DATASET_LIST;
  
  /*  "   ( ,  )" */
  procedure CMFL_LIST
  (
    NEQUIPDSCM              in number,                   -- .     
    COUT                    out clob                     --     
  )
  is
    RDG                     PKG_P8PANELS_VISUAL.TDG;     --  
    RDG_ROW                 PKG_P8PANELS_VISUAL.TDG_ROW; --  
  begin
    /*    */
    UDO_PKG_EQUIPDS_BASE.UTL_ACCESS(STABLE => 'UDO_T_EQUIPDSCMFL', SACTION => 'UDO_EQUIPDSCMFL_SELECT');
    /*    */
    RDG := PKG_P8PANELS_VISUAL.TDG_MAKE();
    /*      */
    PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                        SNAME      => 'NRN',
                                        SCAPTION   => '. ',
                                        SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                        BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                        SNAME      => 'SDATASET',
                                        SCAPTION   => '',
                                        SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR);
    PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                        SNAME      => 'SFILE_NAME',
                                        SCAPTION   => '',
                                        SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR);
    PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                        SNAME      => 'SDESCR',
                                        SCAPTION   => '',
                                        SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR);
    PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                        SNAME      => 'NSTATUS',
                                        SCAPTION   => '',
                                        SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB);
    PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                        SNAME      => 'SERR',
                                        SCAPTION   => '  ',
                                        SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                        BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                        SNAME      => 'SACTIONS',
                                        SCAPTION   => '',
                                        SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR);
    /*   */
    for C in (select T.RN NRN,
                     T.DATASET_ID NDATASET_ID,
                     T.DATASET_TS DDATASET_TS,
                     T.FILE_NAME SFILE_NAME,
                     replace(replace(T.DESCR, CHR(13) || CHR(10), '<br>'), CHR(10), '<br>') SDESCR,
                     T.STATUS NSTATUS,
                     T.ERR SERR
                from UDO_T_EQUIPDSCMFL T
               where T.PRN = NEQUIPDSCM
               order by T.RN)
    loop
      /*     */
      PKG_P8PANELS_VISUAL.TDG_ROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NRN', NVALUE => C.NRN, BCLEAR => true);
      PKG_P8PANELS_VISUAL.TDG_ROW_ADD_COL(RROW   => RDG_ROW,
                                          SNAME  => 'SDATASET',
                                          SVALUE => UDO_PKG_EQUIPDS_BASE.UTL_DATASET_MAKE_NAME(NDATASET_ID => C.NDATASET_ID,
                                                                                               DDATASET_TS => C.DDATASET_TS));
      PKG_P8PANELS_VISUAL.TDG_ROW_ADD_COL(RROW => RDG_ROW, SNAME => 'SFILE_NAME', SVALUE => C.SFILE_NAME);
      PKG_P8PANELS_VISUAL.TDG_ROW_ADD_COL(RROW => RDG_ROW, SNAME => 'SDESCR', SVALUE => C.SDESCR);
      PKG_P8PANELS_VISUAL.TDG_ROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NSTATUS', NVALUE => C.NSTATUS);
      PKG_P8PANELS_VISUAL.TDG_ROW_ADD_COL(RROW => RDG_ROW, SNAME => 'SERR', SVALUE => C.SERR);
      PKG_P8PANELS_VISUAL.TDG_ROW_ADD_COL(RROW => RDG_ROW, SNAME => 'SACTIONS');
      /*     */
      PKG_P8PANELS_VISUAL.TDG_ADD_ROW(RDATA_GRID => RDG, RROW => RDG_ROW);
    end loop;
    /*   */
    COUT := PKG_P8PANELS_VISUAL.TDG_TO_XML(RDATA_GRID => RDG, NINCLUDE_DEF => 1);
  end CMFL_LIST;
  
  /*  "   ( ,  )" */
  procedure CMFL_DEL
  (
    NRN                     in number   --  
  )
  is
  begin
    /*    */
    UDO_PKG_EQUIPDS_BASE.UTL_ACCESS(STABLE => 'UDO_T_EQUIPDSCMFL', SACTION => 'UDO_EQUIPDSCMFL_DELETE', NDOCUMENT => NRN);
    /*    */
    UDO_PKG_EQUIPDS_BASE.CMFL_DEL(NRN => NRN);
  end CMFL_DEL;
  
  /*  "   ( ,  )" */
  procedure CMFL_MAKE
  (
    NEQUIPDSCM              in number,            -- .     
    NDATASET_IDENT          in number,            --   
    NDATASET_CONFIG_IDENT   in number,            --    
    NCLEAR                  in number := 0        --      (0 -  , 1 - )
  )
  is
    NCMFL                   PKG_STD.TREF;         -- .    
    NFILES_CNT              PKG_STD.TNUMBER := 0; --    
    NCONFIG_CNT             PKG_STD.TNUMBER := 0; --    
    DDATASET_TS             PKG_STD.TLDATE;       --      
  begin
    /*   */
    if (NDATASET_IDENT is null) then
      P_EXCEPTION(0,
                  '        .');
    end if;
    if (NDATASET_CONFIG_IDENT is null) then
      P_EXCEPTION(0,
                  '         .');
    end if;
    /*    */
    if (NCLEAR = 1) then
      for C in (select T.RN from UDO_T_EQUIPDSCMFL T where T.PRN = NEQUIPDSCM)
      loop
        UDO_PKG_EQUIPDS_BASE.CMFL_DEL(NRN => C.RN);
      end loop;
    end if;
    /*    */
    DDATASET_TS := sysdate;
    /*     */
    for C in (select F.*
                from FILE_BUFFER F
               where F.IDENT = NDATASET_IDENT
                 and F.DATA is not null
                 and F.BDATA is not null
                 and F.FILENAME is not null)
    loop
      NFILES_CNT := NFILES_CNT + 1;
      UDO_PKG_EQUIPDS_BASE.CMFL_INS(NPRN        => NEQUIPDSCM,
                                    SFILE_NAME  => C.FILENAME,
                                    SDESCR      => C.DATA,
                                    BDATASET    => C.BDATA,
                                    NDATASET_ID => NDATASET_IDENT,
                                    DDATASET_TS => DDATASET_TS,
                                    NRN         => NCMFL);
    end loop;
    /*    */
    for C in (select F.*
                from FILE_BUFFER F
               where F.IDENT = NDATASET_CONFIG_IDENT
                 and F.DATA is not null)
    loop
      NCONFIG_CNT := NCONFIG_CNT + 1;
      UDO_PKG_EQUIPDS_BASE.CM_SET_DATA_CONFIG(NRN => NEQUIPDSCM, BDATA_CONFIG => C.DATA);
    end loop;
    /* ,    */
    if (NFILES_CNT = 0) then
      P_EXCEPTION(0,
                  '      .');
    end if;
    if (NCONFIG_CNT = 0) then
      P_EXCEPTION(0,
                  '       .');
    end if;
    /*   */
    P_FILE_BUFFER_CLEAR(NIDENT => NDATASET_IDENT);
    P_FILE_BUFFER_CLEAR(NIDENT => NDATASET_CONFIG_IDENT);
  end CMFL_MAKE;
  
  /*    "   ( ,  )" */
  procedure CMFL_UPLOAD
  (
    NEQUIPDSCM              in number                              -- .     
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); -- .  
    NIDENT                  PKG_STD.TREF;                          --   
    NTMP                    PKG_STD.TREF;                          -- .   
  begin
    /*    */
    UDO_PKG_EQUIPDS_BASE.UTL_ACCESS(STABLE => 'UDO_T_EQUIPDSCMFL', SACTION => 'UDO_EQUIPDSCMFL_UPLOAD');
    /*      */
    for C in (select T.RN NRN
                from UDO_T_EQUIPDSCMFL T
               where T.PRN = NEQUIPDSCM
                 and T.STATUS in
                     (UDO_PKG_EQUIPDS_BASE.NCMFL_STATUS_REGISTERED, UDO_PKG_EQUIPDS_BASE.NCMFL_STATUS_UPLOAD_ERR))
    loop
      /*   ,      */
      if (NIDENT is null) then
        NIDENT := GEN_IDENT();
      end if;
      /*     */
      P_SELECTLIST_INSERT(NIDENT => NIDENT, NDOCUMENT => C.NRN, SUNITCODE => 'UDO_T_EQUIPDSCMFL', NRN => NTMP);
    end loop;
    /* ,      */
    if (NIDENT is null) then
      P_EXCEPTION(0,
                  '     .      .');
    end if;
    /*   -    */
    for C in (select SL.DOCUMENT NRN
                from SELECTLIST SL
               where SL.IDENT = NIDENT
                 and SL.UNITCODE = 'UDO_T_EQUIPDSCMFL')
    loop
      UDO_PKG_EQUIPDS_BASE.CMFL_SET_STATUS(NRN => C.NRN, NSTATUS => UDO_PKG_EQUIPDS_BASE.NCMFL_STATUS_UPLOADING);
    end loop;
    /*       */
    UDO_PKG_EQUIPDS_DATAPROCESS.UPLOAD(NCOMPANY => NCOMPANY, NIDENT => NIDENT, NEQUIPDSCM => NEQUIPDSCM);
    /*   */
    P_SELECTLIST_CLEAR(NIDENT => NIDENT);
  end CMFL_UPLOAD;
  
  /*    "   ( ,  )" */
  procedure CMFL_SEND_MD
  (
    NEQUIPDSCM              in number,                             -- .     
    NDATASET_ID             in number                              --  
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); -- .  
    NIDENT                  PKG_STD.TREF;                          --   
    NTMP                    PKG_STD.TREF;                          -- .   
  begin
    /*   */
    if (NDATASET_ID is null) then
      P_EXCEPTION(0, '  .');
    end if;
    /*    */
    UDO_PKG_EQUIPDS_BASE.UTL_ACCESS(STABLE => 'UDO_T_EQUIPDSCMFL', SACTION => 'UDO_EQUIPDSCMFL_SEND_MD');
    /*        */
    for C in (select T.RN NRN
                from UDO_T_EQUIPDSCMFL T
               where T.PRN = NEQUIPDSCM
                 and T.DATASET_ID = NDATASET_ID
                 and T.STATUS = UDO_PKG_EQUIPDS_BASE.NCMFL_STATUS_UPLOADED)
    loop
      /*   ,      */
      if (NIDENT is null) then
        NIDENT := GEN_IDENT();
      end if;
      /*     */
      P_SELECTLIST_INSERT(NIDENT => NIDENT, NDOCUMENT => C.NRN, SUNITCODE => 'UDO_T_EQUIPDSCMFL', NRN => NTMP);
    end loop;
    /* ,      */
    if (NIDENT is null) then
      P_EXCEPTION(0,
                  '     .       .');
    end if;
    /*       */
    UDO_PKG_EQUIPDS_DATAPROCESS.SEND_MD(NCOMPANY => NCOMPANY, NIDENT => NIDENT, NEQUIPDSCM => NEQUIPDSCM);
    /*   */
    P_SELECTLIST_CLEAR(NIDENT => NIDENT);
  end CMFL_SEND_MD;
  
  /*  "   ( , )" */
  procedure CMML_LIST
  (
    NEQUIPDSCM              in number,                   -- .     
    COUT                    out clob                     --     
  )
  is
    RDG                     PKG_P8PANELS_VISUAL.TDG;     --  
    RDG_ROW                 PKG_P8PANELS_VISUAL.TDG_ROW; --  
  begin
    /*    */
    UDO_PKG_EQUIPDS_BASE.UTL_ACCESS(STABLE => 'UDO_T_EQUIPDSCMML', SACTION => 'UDO_EQUIPDSCMML_SELECT');
    /*    */
    RDG := PKG_P8PANELS_VISUAL.TDG_MAKE();
    /*      */
    PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                        SNAME      => 'NRN',
                                        SCAPTION   => '. ',
                                        SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                        BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                        SNAME      => 'STASK',
                                        SCAPTION   => '',
                                        SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                        SHINT      => '  :<br>' ||
                                                      UDO_PKG_EQUIPDS_BASE.CMML_TASK_HINT());
    PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                        SNAME      => 'NPRECISION',
                                        SCAPTION   => '',
                                        SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB);
    PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                        SNAME      => 'SDICMUNTS',
                                        SCAPTION   => ' ',
                                        SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                        BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                        SNAME      => 'SDATASET',
                                        SCAPTION   => '',
                                        SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR);
    PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                        SNAME      => 'SUSERPROCS_FRCST_DATA',
                                        SCAPTION   => ' ',
                                        SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                        SHINT      => UDO_PKG_EQUIPDS_BASE.CMML_USERPROCS_FRCST_DATA_HINT());
    PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                        SNAME      => 'NSTATUS',
                                        SCAPTION   => '',
                                        SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB);
    PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                        SNAME      => 'SERR',
                                        SCAPTION   => '  ',
                                        SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                        BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                        SNAME      => 'SACTIONS',
                                        SCAPTION   => '',
                                        SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR);
    /*   */
    for C in (select T.RN NRN,
                     T.TASK STASK,
                     T.PRECISION NPRECISION,
                     DM.MEAS_MNEMO SDICMUNTS,
                     T.DATASET_ID NDATASET_ID,
                     (select F.DATASET_TS
                        from UDO_T_EQUIPDSCMFL F
                       where F.DATASET_ID = T.DATASET_ID
                         and ROWNUM <= 1) DDATASET_TS,
                     UP.CODE SUSERPROCS_FRCST_DATA,
                     T.STATUS NSTATUS,
                     T.ERR SERR
                from UDO_T_EQUIPDSCMML T,
                     UDO_T_EQUIPDSCM   CM,
                     DICMUNTS          DM,
                     USERPROCS         UP
               where CM.RN = NEQUIPDSCM
                 and T.PRN = CM.RN
                 and CM.DICMUNTS = DM.RN
                 and T.USERPROCS_FRCST_DATA = UP.RN
               order by T.RN)
    loop
      /*     */
      PKG_P8PANELS_VISUAL.TDG_ROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NRN', NVALUE => C.NRN, BCLEAR => true);
      PKG_P8PANELS_VISUAL.TDG_ROW_ADD_COL(RROW => RDG_ROW, SNAME => 'STASK', SVALUE => C.STASK);
      PKG_P8PANELS_VISUAL.TDG_ROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NPRECISION', NVALUE => C.NPRECISION);
      PKG_P8PANELS_VISUAL.TDG_ROW_ADD_COL(RROW => RDG_ROW, SNAME => 'SDICMUNTS', SVALUE => C.SDICMUNTS);
      PKG_P8PANELS_VISUAL.TDG_ROW_ADD_COL(RROW   => RDG_ROW,
                                          SNAME  => 'SDATASET',
                                          SVALUE => UDO_PKG_EQUIPDS_BASE.UTL_DATASET_MAKE_NAME(NDATASET_ID => C.NDATASET_ID,
                                                                                               DDATASET_TS => C.DDATASET_TS));
      PKG_P8PANELS_VISUAL.TDG_ROW_ADD_COL(RROW   => RDG_ROW,
                                          SNAME  => 'SUSERPROCS_FRCST_DATA',
                                          SVALUE => C.SUSERPROCS_FRCST_DATA);
      PKG_P8PANELS_VISUAL.TDG_ROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NSTATUS', NVALUE => C.NSTATUS);
      PKG_P8PANELS_VISUAL.TDG_ROW_ADD_COL(RROW => RDG_ROW, SNAME => 'SERR', SVALUE => C.SERR);
      PKG_P8PANELS_VISUAL.TDG_ROW_ADD_COL(RROW => RDG_ROW, SNAME => 'SACTIONS');
      /*     */
      PKG_P8PANELS_VISUAL.TDG_ADD_ROW(RDATA_GRID => RDG, RROW => RDG_ROW);
    end loop;
    /*   */
    COUT := PKG_P8PANELS_VISUAL.TDG_TO_XML(RDATA_GRID => RDG, NINCLUDE_DEF => 1);
  end CMML_LIST;
  
  /*   "   ( , )" */
  procedure CMML_INS
  (
    NPRN                    in number,    -- 
    STASK                   in varchar2,  --  (.  UDO_PKG_EQUIPDS_BASE.SCMML_TASK_*)
    NDATASET_ID             in number,    --  
    SUSERPROCS_FRCST_DATA   in varchar2,  --      
    NRN                     out number    --  
  )
  is
    NUSERPROCS_FRCST_DATA   PKG_STD.TREF; -- .       
  begin
    /*   */
    if (STASK is null) then
      P_EXCEPTION(0, '  .');
    end if;
    if (NDATASET_ID is null) then
      P_EXCEPTION(0, '  .');
    end if;
    if (SUSERPROCS_FRCST_DATA is null) then
      P_EXCEPTION(0,
                  '      .');
    end if;
    /*    */
    UDO_PKG_EQUIPDS_BASE.UTL_ACCESS(STABLE => 'UDO_T_EQUIPDSCMML', SACTION => 'UDO_EQUIPDSCMML_INSERT');
    /*   */
    UDO_PKG_EQUIPDS_BASE.CMML_JOINS(SUSERPROCS_FRCST_DATA => SUSERPROCS_FRCST_DATA,
                                    NUSERPROCS_FRCST_DATA => NUSERPROCS_FRCST_DATA);
    /*   */
    UDO_PKG_EQUIPDS_BASE.CMML_INS(NPRN                  => NPRN,
                                  STASK                 => STASK,
                                  NDATASET_ID           => NDATASET_ID,
                                  NUSERPROCS_FRCST_DATA => NUSERPROCS_FRCST_DATA,
                                  NRN                   => NRN);
  end CMML_INS;

  /*   "   ( , )" */
  procedure CMML_DEL
  (
    NRN                     in number   --  
  )
  is
  begin
    /*    */
    UDO_PKG_EQUIPDS_BASE.UTL_ACCESS(STABLE => 'UDO_T_EQUIPDSCMML', SACTION => 'UDO_EQUIPDSCMML_DELETE', NDOCUMENT => NRN);
    /*   */
    UDO_PKG_EQUIPDS_BASE.CMML_DEL(NRN => NRN);
  end CMML_DEL;  
  
  /*    "   ( , )" */
  procedure CMML_SEND_RQ
  (
    NEQUIPDSCMML            in number                              -- .      
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); -- .  
    RCMML                   UDO_T_EQUIPDSCMML%rowtype;             --  
    NCOUNT                  PKG_STD.TNUMBER;                       --    ,   
  begin
    /*   */
    RCMML := UDO_PKG_EQUIPDS_BASE.CMML_GET(NFLAG_SMART => 0, NRN => NEQUIPDSCMML);
    /*    */
    UDO_PKG_EQUIPDS_BASE.UTL_ACCESS(STABLE    => 'UDO_T_EQUIPDSCMML',
                                    SACTION   => 'UDO_EQUIPDSCMML_SEND_RQ',
                                    NDOCUMENT => RCMML.RN);
    /* ,       ,    */
    begin
      select count(T.RN)
        into NCOUNT
        from UDO_T_EQUIPDSCMFL T
       where T.PRN = RCMML.PRN
         and T.DATASET_ID = RCMML.DATASET_ID
         and T.STATUS = UDO_PKG_EQUIPDS_BASE.NCMFL_STATUS_SENT;
    exception
      when others then
        P_EXCEPTION(0,
                    '      .');
    end;
    if (NCOUNT = 0) then
      P_EXCEPTION(0,
                  '      ,   -  .');
    end if;
    /*     */
    UDO_PKG_EQUIPDS_DATAPROCESS.SEND_RQ(NCOMPANY => NCOMPANY, NEQUIPDSCMML => RCMML.RN);
  end CMML_SEND_RQ;
  
  /*  "   ( , )"    */
  function CMML_STATUS_BY_EQCONFIG
  (
    NEQCONFIG               in number        -- .    
  ) return                  number           --     (0 -  , 1 -     , 2 -   )
  is
    NRES                    PKG_STD.TNUMBER; --   
  begin
    /*   -   */
    NRES := 0;
    /*   */
    for C in (select ML.STATUS
                from UDO_T_EQUIPDSCM   CM,
                     UDO_T_EQUIPDSCMML ML
               where CM.EQOBJKIND = (select CF.OBJ_KIND from EQCONFIG CF where CF.RN = NEQCONFIG)
                 and CM.RN = ML.PRN)
    loop
      /*  ,      */
      if (NRES < 2) then
        NRES := 1;
      end if;
      /*     */
      if (C.STATUS = UDO_PKG_EQUIPDS_BASE.NCMML_STATUS_PROCESSED) then
        NRES := 2;
      end if;
    end loop;
    /*   */
    return NRES;
  end CMML_STATUS_BY_EQCONFIG;
  
  /*  "   ( , )"    */
  procedure CMML_LIST_BY_EQCONFIG
  (
    NEQCONFIG               in number,                   -- .    
    COUT                    out clob                     --   
  )
  is
    RDG                     PKG_P8PANELS_VISUAL.TDG;     --  
    RDG_ROW                 PKG_P8PANELS_VISUAL.TDG_ROW; --  
  begin
    /*    */
    RDG := PKG_P8PANELS_VISUAL.TDG_MAKE();
    /*      */
    PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                        SNAME      => 'NRN',
                                        SCAPTION   => '.  ',
                                        SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                        BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                        SNAME      => 'NEQUIPDS',
                                        SCAPTION   => '.  ',
                                        SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                        BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                        SNAME      => 'NEQUIPDSCM',
                                        SCAPTION   => '.    ',
                                        SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                        BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                        SNAME      => 'SNEQUIPDS',
                                        SCAPTION   => '',
                                        SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR);
    PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                        SNAME      => 'STASK',
                                        SCAPTION   => '',
                                        SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                        SHINT      => '  :<br>' ||
                                                      UDO_PKG_EQUIPDS_BASE.CMML_TASK_HINT());
    PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                        SNAME      => 'NPRECISION',
                                        SCAPTION   => '',
                                        SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB);
    PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                        SNAME      => 'SDICMUNTS',
                                        SCAPTION   => ' ',
                                        SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                        BVISIBLE   => false);
        PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                        SNAME      => 'SUSERPROCS_FRCST_DATA',
                                        SCAPTION   => ' ',
                                        SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                        SHINT      => UDO_PKG_EQUIPDS_BASE.CMML_USERPROCS_FRCST_DATA_HINT());
    PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                        SNAME      => 'NSTATUS',
                                        SCAPTION   => '',
                                        SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB);
    PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                        SNAME      => 'SERR',
                                        SCAPTION   => '  ',
                                        SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                        BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                        SNAME      => 'SACTIONS',
                                        SCAPTION   => '',
                                        SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR);
    /*   */
    for C in (select T.RN          NRN,
                     CM.PRN        NEQUIPDS,
                     T.PRN         NEQUIPDSCM,
                     DS.NAME       SNEQUIPDS,
                     T.TASK        STASK,
                     UP.CODE       SUSERPROCS_FRCST_DATA,
                     T.PRECISION   NPRECISION,
                     DM.MEAS_MNEMO SDICMUNTS,
                     T.STATUS      NSTATUS,
                     T.ERR         SERR
                from UDO_T_EQUIPDSCMML T,
                     UDO_T_EQUIPDSCM   CM,
                     UDO_T_EQUIPDS     DS,
                     DICMUNTS          DM,
                     USERPROCS         UP
               where T.PRN = CM.RN
                 and CM.PRN = DS.RN
                 and CM.DICMUNTS = DM.RN
                 and CM.EQOBJKIND = (select CF.OBJ_KIND from EQCONFIG CF where CF.RN = NEQCONFIG)
                 and T.USERPROCS_FRCST_DATA = UP.RN
               order by T.RN)
    loop
      /*     */
      PKG_P8PANELS_VISUAL.TDG_ROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NRN', NVALUE => C.NRN, BCLEAR => true);
      PKG_P8PANELS_VISUAL.TDG_ROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NEQUIPDS', NVALUE => C.NEQUIPDS);
      PKG_P8PANELS_VISUAL.TDG_ROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NEQUIPDSCM', NVALUE => C.NEQUIPDSCM);
      PKG_P8PANELS_VISUAL.TDG_ROW_ADD_COL(RROW => RDG_ROW, SNAME => 'SNEQUIPDS', SVALUE => C.SNEQUIPDS);
      PKG_P8PANELS_VISUAL.TDG_ROW_ADD_COL(RROW => RDG_ROW, SNAME => 'STASK', SVALUE => C.STASK);
      PKG_P8PANELS_VISUAL.TDG_ROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NPRECISION', NVALUE => C.NPRECISION);
      PKG_P8PANELS_VISUAL.TDG_ROW_ADD_COL(RROW => RDG_ROW, SNAME => 'SDICMUNTS', SVALUE => C.SDICMUNTS);
      PKG_P8PANELS_VISUAL.TDG_ROW_ADD_COL(RROW => RDG_ROW, SNAME => 'SUSERPROCS_FRCST_DATA', SVALUE => C.SUSERPROCS_FRCST_DATA);
      PKG_P8PANELS_VISUAL.TDG_ROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NSTATUS', NVALUE => C.NSTATUS);
      PKG_P8PANELS_VISUAL.TDG_ROW_ADD_COL(RROW => RDG_ROW, SNAME => 'SERR', SVALUE => C.SERR);
      PKG_P8PANELS_VISUAL.TDG_ROW_ADD_COL(RROW => RDG_ROW, SNAME => 'SACTIONS');
      /*     */
      PKG_P8PANELS_VISUAL.TDG_ADD_ROW(RDATA_GRID => RDG, RROW => RDG_ROW);
    end loop;
    /*   */
    COUT := PKG_P8PANELS_VISUAL.TDG_TO_XML(RDATA_GRID => RDG, NINCLUDE_DEF => 1);
  end CMML_LIST_BY_EQCONFIG;
  
  /*    "   ( , ,  )" */
  procedure CMMLH_BUILD_FORECAST
  (
    COUT                    out clob         --  
  )
  is
    NCUR                    integer;         --    
    XDOC                    PKG_XMAKE.TNODE; --   
    XROOT                   PKG_XMAKE.TNODE; --    
    NFORECAST               PKG_STD.TNUMBER; --    
  begin
    /*   -          */
    NFORECAST := ROUND(DBMS_RANDOM.VALUE(10, 60));
    /*   */
    NCUR := PKG_XMAKE.OPEN_CURSOR();
    /*   */
    XROOT := PKG_XMAKE.CONCAT(ICURSOR => NCUR,
                              RNODE00 => XROOT,
                              RNODE01 => PKG_XMAKE.ELEMENT(ICURSOR  => NCUR,
                                                           SNAME    => 'NFORECAST',
                                                           RVALUE00 => PKG_XMAKE.VALUE(ICURSOR => NCUR, NVALUE => NFORECAST)));
    /*  XML-  */
    XDOC := PKG_XMAKE.ELEMENT(ICURSOR => NCUR, SNAME => 'XDATA', RNODE00 => XROOT);
    /*   CLOB */
    COUT := PKG_XMAKE.SERIALIZE_TO_CLOB(ICURSOR => NCUR,
                                        ITYPE   => PKG_XMAKE.CONTENT_,
                                        RNODE   => XDOC,
                                        RHEADER => PKG_XHEADER.WRAP_ALL(SVERSION    => PKG_XHEADER.VERSION_1_0_,
                                                                        SENCODING   => PKG_XHEADER.ENCODING_UTF_,
                                                                        SSTANDALONE => PKG_XHEADER.STANDALONE_YES_));
    /*   */
    PKG_XMAKE.CLOSE_CURSOR(ICURSOR => NCUR);
  end CMMLH_BUILD_FORECAST;
  
  /*      "   ( , ,  )" */
  procedure CMMLH_PARSE_FORECAST
  (
    CFORECAST               in clob,             --  
    NFORECAST               out number           --  
  )
  is
    XDOC                    PKG_XPATH.TDOCUMENT; --  -
    XROOT                   PKG_XPATH.TNODE;     --   
  begin
    /*  - */
    XDOC := PKG_XPATH.PARSE_FROM_CLOB(LCXML => CFORECAST);
    /*    */
    XROOT := PKG_XPATH.ROOT_NODE(RDOCUMENT => XDOC);
    /*   */
    NFORECAST := PKG_XPATH.VALUE_NUM(RNODE => PKG_XPATH.SINGLE_NODE(RPARENT_NODE => XROOT, SPATTERN => 'XDATA/NFORECAST'));
  exception
    when others then
      null;
  end CMMLH_PARSE_FORECAST;
  
  /*  "   ( , ,  )"    */
  procedure CMMLH_LIST_BY_EQCONFIG
  (
    NEQCONFIG               in number,                   -- .    
    COUT                    out clob                     --   
  )
  is
    RDG                     PKG_P8PANELS_VISUAL.TDG;     --  
    RDG_ROW                 PKG_P8PANELS_VISUAL.TDG_ROW; --  
  begin
    /*    */
    RDG := PKG_P8PANELS_VISUAL.TDG_MAKE();
    /*      */
    PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                        SNAME      => 'NRN',
                                        SCAPTION   => '. ',
                                        SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                        BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                        SNAME      => 'SRQ_AUTHID',
                                        SCAPTION   => '',
                                        SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR);
    PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                        SNAME      => 'SRQ_DATE',
                                        SCAPTION   => '/ ',
                                        SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR);
    PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                        SNAME      => 'SEQUIPDS_CODE',
                                        SCAPTION   => '',
                                        SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR);
    PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                        SNAME      => 'SEQUIPDSCMML_TASK',
                                        SCAPTION   => '',
                                        SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                        SHINT      => UDO_PKG_EQUIPDS_BASE.CMML_TASK_HINT());
    PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                        SNAME      => 'NEQUIPDSCMML_PRECISION',
                                        SCAPTION   => '',
                                        SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB);
    PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                        SNAME      => 'STO_FORECAST_DESC',
                                        SCAPTION   => '',
                                        SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                        SHINT      => '<b> :</b> "XX / YY%", <br>' ||
                                                      '<b>XX</b> -            (///   ..)<br>' ||
                                                      '<b>YY%</b> -          <br><br>' ||
                                                      '<b> :</b><br>' ||
                                                      UDO_PKG_EQUIPTCF.EQCONFIG_THOBJ_FORECAST_CLR(NMODE => 0));
    PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                        SNAME      => 'STO_FORECAST_DESC_COLOR',
                                        SCAPTION   => ' ',
                                        SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                        BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                        SNAME      => 'STO_FORECAST',
                                        SCAPTION   => '      ',
                                        SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                        BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                        SNAME      => 'SDICMUNTS',
                                        SCAPTION   => ' ',
                                        SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                        BVISIBLE   => false);
    /*   */
    for C in (select T.RN NRN,
                     T.RQ_AUTHID SRQ_AUTHID,
                     T.RQ_DATE DRQ_DATE,
                     TO_CHAR(T.RQ_DATE, 'dd.mm.yyyy hh24:mi:ss') SRQ_DATE,
                     DS.CODE SEQUIPDS_CODE,
                     ML.TASK SEQUIPDSCMML_TASK,
                     ML.PRECISION NEQUIPDSCMML_PRECISION,
                     DM.MEAS_MNEMO SDICMUNTS,
                     T.FORECAST BFORECAST,
                     null NFORECAST,
                     null STO_FORECAST_DESC,
                     null STO_FORECAST_DESC_COLOR,
                     null STO_FORECAST
                from UDO_T_EQUIPDSCMMLH T,
                     UDO_T_EQUIPDSCMML  ML,
                     UDO_T_EQUIPDSCM    CM,
                     UDO_T_EQUIPDS      DS,
                     DICMUNTS           DM
               where T.EQCONFIG = NEQCONFIG
                 and T.PRN = ML.RN
                 and ML.PRN = CM.RN
                 and CM.PRN = DS.RN
                 and CM.DICMUNTS = DM.RN
               order by T.RN desc)
    loop
      /*      */
      CMMLH_PARSE_FORECAST(CFORECAST => BLOB2CLOB(LBDATA => C.BFORECAST), NFORECAST => C.NFORECAST);
      /*       .  */
      UDO_PKG_EQUIPTCF.EQCONFIG_THOBJ_FORECAST_CRD(NEQCONFIG      => NEQCONFIG,
                                                   DFORECAST_DATE => C.DRQ_DATE,
                                                   NFORECAST      => C.NFORECAST,
                                                   SDICMUNTS      => C.SDICMUNTS,
                                                   STASK          => C.SEQUIPDSCMML_TASK,
                                                   COUT           => C.STO_FORECAST);
      /*              .  */
      UDO_PKG_EQUIPTCF.EQCONFIG_THOBJ_FORECAST_CRDP(CFORECAST            => C.STO_FORECAST,
                                                    SFORECAST_DESC       => C.STO_FORECAST_DESC,
                                                    SFORECAST_DESC_COLOR => C.STO_FORECAST_DESC_COLOR);
      /*     */
      PKG_P8PANELS_VISUAL.TDG_ROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NRN', NVALUE => C.NRN, BCLEAR => true);
      PKG_P8PANELS_VISUAL.TDG_ROW_ADD_COL(RROW => RDG_ROW, SNAME => 'SRQ_AUTHID', SVALUE => C.SRQ_AUTHID);
      PKG_P8PANELS_VISUAL.TDG_ROW_ADD_COL(RROW => RDG_ROW, SNAME => 'SRQ_DATE', SVALUE => C.SRQ_DATE);
      PKG_P8PANELS_VISUAL.TDG_ROW_ADD_COL(RROW => RDG_ROW, SNAME => 'SEQUIPDS_CODE', SVALUE => C.SEQUIPDS_CODE);
      PKG_P8PANELS_VISUAL.TDG_ROW_ADD_COL(RROW => RDG_ROW, SNAME => 'SEQUIPDSCMML_TASK', SVALUE => C.SEQUIPDSCMML_TASK);
      PKG_P8PANELS_VISUAL.TDG_ROW_ADD_COL(RROW   => RDG_ROW,
                                          SNAME  => 'NEQUIPDSCMML_PRECISION',
                                          NVALUE => C.NEQUIPDSCMML_PRECISION);
      PKG_P8PANELS_VISUAL.TDG_ROW_ADD_COL(RROW => RDG_ROW, SNAME => 'STO_FORECAST_DESC', SVALUE => C.STO_FORECAST_DESC);
      PKG_P8PANELS_VISUAL.TDG_ROW_ADD_COL(RROW   => RDG_ROW,
                                          SNAME  => 'STO_FORECAST_DESC_COLOR',
                                          SVALUE => C.STO_FORECAST_DESC_COLOR);
      PKG_P8PANELS_VISUAL.TDG_ROW_ADD_COL(RROW => RDG_ROW, SNAME => 'STO_FORECAST', SVALUE => C.STO_FORECAST);
      PKG_P8PANELS_VISUAL.TDG_ROW_ADD_COL(RROW => RDG_ROW, SNAME => 'SDICMUNTS', SVALUE => C.SDICMUNTS);
      /*     */
      PKG_P8PANELS_VISUAL.TDG_ADD_ROW(RDATA_GRID => RDG, RROW => RDG_ROW);
    end loop;
    /*   */
    COUT := PKG_P8PANELS_VISUAL.TDG_TO_XML(RDATA_GRID => RDG, NINCLUDE_DEF => 1);
  end CMMLH_LIST_BY_EQCONFIG;
  
end UDO_PKG_EQUIPDS;
/
