create or replace procedure UDO_P_EQCONFIG_DATASET_MAKE
/*         */
(
  NEQCONFIG                 in number,  -- .   
  DBEG                      in date,    --  ""
  DEND                      in date,    --  ""
  NDATASET_IDENT            out number, --   
  NDATASET_CONFIG_IDENT     out number  --    
)
is
begin
  for C in (select T.COMPANY,
                   T.RN
              from EQCONFIG T
             where T.RN = NEQCONFIG)
  loop
    UDO_PKG_EQUIPDS_DATAPROCESS.DATASET_CONF_SET(NCOMPANY              => C.COMPANY,
                                                 NEQCONFIG             => C.RN,
                                                 DBEG                  => DBEG,
                                                 DEND                  => DEND,
                                                 NLENGTH_GB            => 1,
                                                 NDATASET_IDENT        => NDATASET_IDENT,
                                                 NDATASET_CONFIG_IDENT => NDATASET_CONFIG_IDENT);
  end loop;
end UDO_P_EQCONFIG_DATASET_MAKE;
/
