/*    ( , ,  ) */
create table UDO_T_EQUIPDSCMMLH
(
  /*   */
  RN                        number(17) not null,
  /*  */
  PRN                       number(17) not null,
  /* .    */
  EQCONFIG                  number(17) not null,
  /* ,   */
  RQ_AUTHID                 varchar2(30) not null,
  /* /  */
  RQ_DATE                   date not null,
  /*   */
  RQ                        blob,
  /*   */
  FORECAST                  blob,
  /*    */
  EXSQUEUE                  number(17) default null,
  /*  */
  constraint UDO_C_EQUIPDSCMMLH_RN_PK primary key (RN),
  constraint UDO_C_EQUIPDSCMMLH_PRN_FK foreign key (PRN) references UDO_T_EQUIPDSCMML(RN),
  constraint UDO_C_EQUIPDSCMMLH_EQCONFIG_FK foreign key (EQCONFIG) references EQCONFIG(RN),  
  constraint UDO_C_EQUIPDSCMMLH_RQAUTHID_NB check (rtrim(RQ_AUTHID) is not null),
  constraint UDO_C_EQUIPDSCMMLH_EXSQUEUE_FK foreign key (EXSQUEUE) references EXSQUEUE(RN),
  constraint UDO_C_EQUIPDSCMMLH_UN unique (PRN, RQ_AUTHID, RQ_DATE)
);
